package com.example.dsosnowski.arduinosensors;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import java.util.Set;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Intent;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;
//import android.content.Context;

public class DeviceActivity extends AppCompatActivity {
    // declare textview for view status
    TextView text;

    // EXTRA string to send on to mainactivity
    public static String EXTRA_DEVICE_ADDRESS = "device_address";
    public static String EXTRA_DEVICE_NAME = "device_name";

    // Member fields
    private BluetoothAdapter myBtAdapter;
    private ArrayAdapter<String> myDevicesArrayAdapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_device);
        //mycontext = getApplicationContext();
    }

    @Override
    public void onResume()
    {
        super.onResume();
        //***************
        checkBTState();

        text = (TextView) findViewById(R.id.id_devices_title);
        text.setTextSize(20);
        text.setText(R.string.stringDevicesSelect);

        // Initialize array adapter for paired devices
        myDevicesArrayAdapter = new ArrayAdapter<String>(this, R.layout.device_name);

        // Find and set up the ListView for paired devices
        ListView listPariedDevices = (ListView) findViewById(R.id.id_devices_list);
        listPariedDevices.setAdapter(myDevicesArrayAdapter);
        listPariedDevices.setOnItemClickListener(myDeviceClickListener);

        // Get the local Bluetooth adapter
        myBtAdapter = BluetoothAdapter.getDefaultAdapter();

        // Get a set of currently paired devices and append to 'pairedDevices'
        Set<BluetoothDevice> pairedDevices = myBtAdapter.getBondedDevices();

        // Add previosuly paired devices to the array
        if (pairedDevices.size() > 0) {
            for (BluetoothDevice device : pairedDevices) {
                myDevicesArrayAdapter.add(device.getName() + "\n" + device.getAddress());
            }
        }
        else {
            Toast.makeText(getBaseContext(), "Nie znaleziono urządzeń",Toast.LENGTH_SHORT).show();
        }
    }

    // Set up on-click listener for the list
    private OnItemClickListener myDeviceClickListener = new OnItemClickListener() {
        public void onItemClick(AdapterView<?> av, View v, int arg2, long arg3) {
            text.setText(R.string.stringDevicesConnecting);

            // Get the device MAC address, which is the last 17 chars in the View
            String info = ((TextView) v).getText().toString();
            int charPos = info.indexOf("\n", 0) + 1;
            String name = info.substring(0, charPos);
            String address = info.substring(info.length() - 17);

            // Make an intent to start next activity while taking an extra which is the MAC address.
            Intent myIntent = new Intent(DeviceActivity.this, MainActivity.class);
            myIntent.putExtra(EXTRA_DEVICE_ADDRESS, address);
            myIntent.putExtra(EXTRA_DEVICE_NAME, name);
            startActivity(myIntent);
        }
    };

    private void checkBTState() {
        // Check device has Bluetooth and that it is turned on
        myBtAdapter = BluetoothAdapter.getDefaultAdapter(); // CHECK THIS OUT THAT IT WORKS!!!
        if(myBtAdapter == null) {
            Toast.makeText(getBaseContext(), "Urządzenie nie obsługuje Bluetooth", Toast.LENGTH_SHORT).show();
        }
        else {
            if (!myBtAdapter.isEnabled()) {
                //Prompt user to turn on Bluetooth
                Intent intentBtEnable = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
                startActivityForResult(intentBtEnable, 1);
            }
        }
    }
}
